import "choerodon-ui/pro/lib/data-set/style";
import _DataSet from "choerodon-ui/pro/lib/data-set";

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) { symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); } keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

import React, { createContext, useContext, useEffect, useMemo } from 'react';
import { injectIntl } from 'react-intl';
import { inject } from 'mobx-react';
import some from 'lodash/some';
import FormDataSet from "./FormDataSet"; // @ts-ignore

var HAS_BASE_PRO = false;

try {
  require.resolveWeak('@choerodon/testmanager-pro');

  HAS_BASE_PRO = true;
} catch (error) {}

var Store = /*#__PURE__*/createContext({});
export function useCreateHostStore() {
  return useContext(Store);
}
export var StoreProvider = injectIntl(inject('AppState')(function (props) {
  var children = props.children,
      formatMessage = props.intl.formatMessage,
      _props$AppState$curre = props.AppState.currentMenuType,
      projectId = _props$AppState$curre.projectId,
      categories = _props$AppState$curre.categories,
      hostId = props.hostId,
      hostType = props.hostType;
  var intlPrefix = 'c7ncd.host.config';
  var typeDs = useMemo(function () {
    return new _DataSet({
      data: [{
        text: formatMessage({
          id: "".concat(intlPrefix, ".type.test")
        }),
        value: 'distribute_test'
      }, {
        text: formatMessage({
          id: "".concat(intlPrefix, ".type.deploy")
        }),
        value: 'deploy'
      }],
      selection: 'single'
    });
  }, []);
  var accountDs = useMemo(function () {
    return new _DataSet({
      data: [{
        text: formatMessage({
          id: "".concat(intlPrefix, ".account.password")
        }),
        value: 'accountPassword'
      }, {
        text: formatMessage({
          id: "".concat(intlPrefix, ".account.token")
        }),
        value: 'publickey'
      }],
      selection: 'single'
    });
  }, []);
  var showTestTab = useMemo(function () {
    return HAS_BASE_PRO && some(categories, ['code', 'N_TEST']);
  }, [categories, HAS_BASE_PRO]);
  var formDs = useMemo(function () {
    return new _DataSet(FormDataSet({
      formatMessage: formatMessage,
      intlPrefix: intlPrefix,
      projectId: projectId,
      typeDs: typeDs,
      accountDs: accountDs,
      hostId: hostId,
      showTestTab: showTestTab,
      hostType: hostType
    }));
  }, [projectId]);
  useEffect(function () {
    if (hostId) {
      formDs.query();
    } else {
      formDs.create();
    }
  }, [projectId, hostId]);

  var value = _objectSpread(_objectSpread({}, props), {}, {
    intlPrefix: intlPrefix,
    prefixCls: 'c7ncd-host-config-create',
    formatMessage: formatMessage,
    projectId: projectId,
    formDs: formDs,
    showTestTab: showTestTab
  });

  return /*#__PURE__*/React.createElement(Store.Provider, {
    value: value
  }, children);
}));